(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





BeginPackage["Architecture`CLAIncr`","Architecture`Main`"]



Begin["`Private`"]



Description[
    "CLAIncr"]:="The CLAIncr architecture is based on the clustered \
look-ahead approach with incremental output computation. Also called Direct \
Form Block Filter by Parhi. Fast FIR filter techniques might be used to \
improve this architecture further. Note that this filter is not necessarily \
stable. See: parhi89pipeline2."

ParamNr["CLAIncr"]:=3

ParamDescription["CLAIncr"][
    3]:="The number of pipeline stages  in the recursive loop of the \
implementation. Must be a power of two. Default = 1."

ParamTest["CLAIncr"][param_,3]:=
  And[param[[3]]\[GreaterEqual] 1,
    Round[Log[2,param[[3]]]]\[Equal] Log[2,param[[3]]]]



ParamFindThroughput["CLAIncr"][n_,t_]:=Module[{p,m,sol},
    m=1;
    While[ResponseTime["CLAIncr"][{n,p,m}]>1,m=2m];
    sol = Solve[Throughput["CLAIncr"][{n,p,m}] \[Equal] t,p];
    If[Length[sol]\[Equal]0, {0,0,0},{n,p,m} /. sol[[1]]]]

WorkUnit["CLAIncr"][{N_,P_,M_:1}]:={1,N}/M



\!\(\(HardwareMultipliers["\<CLAIncr\>"]\)[{N_, P_, M_:  1}] := 
    If[P \[GreaterEqual] \ N, 
      P \((3\ N\  + \ 1)\)\  - \ \((\((N + 1)\) N/2)\) + 
        N\^2\ Log[2, M], \((2\ N\  + \ \((P + 1)\)/2)\) P\  + \ 
        N\ P\ Log[2, M]]\)

\!\(\(HardwareAdders["\<CLAIncr\>"]\)[{N_, P_, M_:  1}] := 
    If[N \[GreaterEqual] \ P, 
      P \((3\ N\  + \ 1)\)\  - \ \((\((N + 1)\) N/2)\) + \ 
        N\^2\ Log[2, M], \((2\ N\  + \ \((P + 1)\)/2)\) P + \ 
        N\ P\ Log[2, M]]\)

HardwareBuffers["CLAIncr"][{N_,P_,M_:1}]:= M N + N + (M - 1) P

Latency["CLAIncr"][{N_,P_,M_:1}]:=
  ResponseTime[arch_][param_]*((2N + M+ P )/N + Log[2,M])

End[]



EndPackage[]