(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





BeginPackage["Architecture`IncrementalBlockStateAllpass`","Architecture`Main`\
"]



Begin["`Private`"]



Description[
    "IncrementalBlockStateAllpass"]:="The incremental block-state all-pass \
architecture, is based on the block-state all-pass architecture like the \
incremental block-state architecture is based on the block-state \
architecture. Again the drawback is that the A matrix becomes full."

ParamNr["IncrementalBlockStateAllpass"]:=4

ParamDescription["IncrementalBlockStateAllpass"][
    3]:="The increment size. Outputs will be calculated in groups of this \
size. This means that the increment size should be between 1 and the number \
of simultaneous inputs/outputs. Note that if the increment size is half of \
that or larger, then this architecture is the same as the BlockStateAllpass \
architecture."

ParamDescription["IncrementalBlockStateAllpass"][
    4]:="The number of pipeline stages  in the recursive loop of the \
implementation. Must be a power of two. Default = 1."

ParamMax["IncrementalBlockStateAllpass"][param_,3]:=param[[2]]

ParamTest["IncrementalBlockStateAllpass"][param_,4]:=
  And[param[[4]]\[GreaterEqual] 1,
    Round[Log[2,param[[4]]]]\[Equal] Log[2,param[[4]]]]



ParamFindThroughput["IncrementalBlockStateAllpass"][n_,t_]:=
  Block[{p,i,m,sol}, 
    m=1;
    While[ResponseTime["IncrementalBlockStateAllpass"][{n,p,i,m}]>1,m=2m];
    sol = 
      Solve[Throughput["IncrementalBlockStateAllpass"][{n,p,i,m}] \[Equal] t,
        p];
    p=p /. sol[[1]];
    i=FindIncrement[n,p,m];
    {n,p,i,m}]

WorkUnit["IncrementalBlockStateAllpass"][{N_,P_,i_:1,M_:1}]:={1,N}/M

\!\(\(HardwareMultipliers["\<IncrementalBlockStateAllpass\>"]\)[{n_, P_, I_, 
        M_:  1}] := 
    2  n \((P + Quotient[P, I])\)\  + \ \((P \((I + 1)\))\)/
        2\  + \ \((Mod[P, I] \((I + Mod[P, I])\))\)/2\  + \ 
      n\ I \((Quotient[P, I] - 1)\)\  + \ n\^2\ Log[2, M]\  - 2  n\  + \ 
      n\^2 - \((\((I + Mod[P, I])\)\ n\  - \ 
          n \((n + 1)\)/2)\)\  - \((Quotient[P, I] - 1)\) \((I\ n\  - \ 
            n \((n + 1)\)/2)\)\)

\!\(\(HardwareAdders["\<IncrementalBlockStateAllpass\>"]\)[{n_, P_, I_, 
        M_:  1}] := 
    2\ n\ \((P + Quotient[P, I])\)\  + \ \((P \((I + 1)\))\)/
        2\  + \ \((Mod[P, I] \((I + Mod[P, I])\))\)/2\  + \ 
      n\ I \((Quotient[P, I] - 1)\) + \ n\^2\ Log[2, M] - 2  n\  + \ 
      n\^2\  - \((\((I + Mod[P, I])\)\ n\  - \ 
          n \((n + 1)\)/2)\)\  - \((Quotient[P, I] - 1)\) \((I\ n\  - \ 
            n \((n + 1)\)/2)\)\)

HardwareBuffers["IncrementalBlockStateAllpass"][{N_,P_,i_:1,M_:1}]:= 
  N M + (M-1)(P+N)

Latency["IncrementalBlockStateAllpass"][{N_,P_,I_:1,M_:1}]:=
  ResponseTime[arch_][{N,P,I,M}]*(N + 2 P +Quotient[P,I]- 2)/N

FindIncrement[N_,P_,M_:1]:=
  Block[{i,opt,opti},opt = Infinity;
    For[i = 1, i\[LessEqual](P/2) + 1,
      If[HardwareMultipliers["IncrementalBlockStateAllpass"][{N,P,i,M}]<opt,
        opt=HardwareMultipliers["IncrementalBlockStateAllpass"][{N,P,i,M}];
        opti=i;i++,i++]];opti]

HardwareMultipliers["IncrementalBlockStateAllpass"][{N_,P_}]:=
  HardwareMultipliers["IncrementalBlockStateAllpass"][{N,P, 
      FindIncrement[N,P]}]

HardwareAdders["IncrementalBlockState"][{N_,P_}]:=
  HardwareAdders["IncrementalBlockStateAllpass"][{N,P,FindIncrement[N,P]}]

Latency["IncrementalBlockStateAllpass"][{N_,P_}]:=
  Latency["IncrementalBlockState"][{N,P,FindIncrement[N,P]}]

End[]



EndPackage[]