(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





BeginPackage["Architecture`Main`"]



ArchitectureListIIR:={"BlockState","IncrementalBlockState",
      "ParallelBlockState","SLA","SLAIncr","CLAIncr"};

ArchitectureListAllpass:={"CLAAllpass","BlockStateAllpass", 
      "IncrementalBlockStateAllpass"};

ArchitectureList:=Union[ArchitectureListIIR,ArchitectureListAllpass];



ArchitectureList::usage=
    "ArchitectureList gives a list of valid architecture handles.";

ArchitectureListIIR::usage=
    "ArchitectureListIIR gives a list of valid architecture handles for \
general IIR architectures.";

ArchitectureListAllpass::usage=
    "ArchitectureListAllpass gives a list of valid architecture handles for \
architectures specifically designed for Allpass filters.";

Description::usage=
    "Description[arch] gives a description of the architecture, and \
references to the literature.";

ParamNr::usage=
    "ParamNr[arch] gives the number of parameters needed by the architecture. \
This is at least two for any architecture";

ParamDescription::usage= 
    "ParamDescription[arch][n] gives a description of the n-th parameter of \
the architecture. 1 \[LessEqual] n \[LessEqual] ParamNr[arch]";

ParamMin::usage=
    "ParamMin[arch][param, n] gives the minimum possible value of the n-th \
parameter of the architecture. 1 \[LessEqual] n \[LessEqual] ParamNr[arch]";

ParamMax::usage=
    "ParamMin[arch][param, n] gives the maximum possible value of the n-th \
parameter of the architecture. 1 \[LessEqual] n \[LessEqual] ParamNr[arch]";

ParamFindHardwareMultipliers::usage="ParamFindHardwareMultipliers[arch][n,t] \
gives the parameters for an instance of the architecture, such that it \
contains t hardware multipliers. If this is not possible, it wil return a \
list containing only zeros. The parameters returned by this function do not \
have to be valid, use the ParamTest function to check this."



ParamFindThroughput::usage="ParamFindThroughput[arch][n,t] gives the \
parameters for an instance of the architecture, such that it can handle a \
filter of order n at a throughput of t. If this is not possible, it wil \
return a list containing only zeros. The parameters returned by this function \
do not have to be valid, use the ParamTest function to check this."



ParamTest::usage="ParamTest[arch][param,n] tests whether the value of the \
n-th parameter is valid for the architecture (and with respect to the other \
parameters).
ParamTest[arch][param] tests whether the all parameters are valid for the \
architecture."



\!\(\(ClockCycle::usage = \*"\"\<ClockCycle[arch][param] gives the length of \
a clock cycle of the architecture. This length is expressed in \!\(T\_m\) and \
\!\(T\_a\), representing the time it takes to do a multiplication and \
addition respectively. See also WorkUnit and NeededCycles.\>\"";\)\)

NeededCycles::usage=
    "NeededCycles[arch][param, {mults, adds}] gives the number of clock \
cycles required to perform mults multiplications and adds additions. This \
function returns 1 by default, but can be overridden to simulate hardware \
restrictions. See also ClockCycle and WorkUnit.";

WorkUnit::usage=
    "WorkUnit[arch][param] gives a list of two elements containing the number \
of multiplications and additions respectively needed (ideally) in a single \
cycle. Note the word 'ideally', whether or not this is possible depends on \
the NeededCycles function. See also ClockCycle and NeededCycles.";

HardwareMultipliers::usage=
    "HardwareMultipliers[arch][param] gives the number of multipliers needed \
by the architecture.";

HardwareAdders::usage=
    "HardwareAdders[arch][param] gives the number of adders needed by the \
architecture.";

HardwareBuffers::usage=
    "HardwareBuffers[arch][param] gives the number of buffers needed by the \
architecture.";

Latency::usage = 
    "Latency[arch][param] (average) latency of the architecture in clock \
cycles.";

Throughput::usage=
    "Throughput[arch][param] the number of samples processed per clock cycle \
on average. Note that the second parameter already indicates the number of \
simultaneous inputs, so the throughput is effectively the second parameter \
divided by the response time.";

ResponseTime::usage = 
    "ResponseTime[arch][param] the number of clock cycles between accepting \
inputs.";

Usage::usage=
    "Usage[arch][param] the fraction of the hardware that is busy at any \
given moment.";

ConstantsNr::usage=
    "ConstantsNr[arch][param] the number of constants in the architecture. \
This gives an indication of how many locations have to be updated if the \
filter coefficients change.";

ConstantsUniqueNr::usage=
    "ConstantsUniqueNr[arch][param] the number of unique constants in the \
architecture. This gives an indication of how many calculations have to be \
performed if the filter coefficients change. Note that this is a worst case \
number, in special cases more constants may be equal.";





Begin["`Private`"]



ParamNr[arch_]:=2

ParamDescription[arch_][1]:="Order of the filter."

ParamDescription[arch_][2]:="Number of simultaneous inputs."

ParamMin[arch_][param_,n_]:=1

ParamMax[arch_][param_,n_]:=Infinity

ParamFindHardwareMultipliers[arch_][n_,h_]:=Module[{sol},
    Off[Solve::"ifun"];
    sol = Solve[
        HardwareMultipliers[arch][
            Table[p[i],{i,ParamNr[arch]}]/. {p[1]\[Rule] n}] \[Equal] h,
        Table[p[i],{i,2,ParamNr[arch]}]];
    If[Length[sol]\[Equal]0, Table[0,{i,ParamNr[arch]}],
      Table[p[i],{i,ParamNr[arch]}] /. sol[[1]] /. {p[1]\[Rule] n}]]

ParamFindThroughput[arch_][n_,t_]:=Module[{sol},
    Off[Solve::"ifun"];
    sol = Solve[
        Throughput[arch][
            Table[p[i],{i,ParamNr[arch]}]/. {p[1]\[Rule] n}] \[Equal] t,
        Table[p[i],{i,2,ParamNr[arch]}]];
    If[Length[sol]\[Equal]0, Table[0,{i,ParamNr[arch]}],
      Table[p[i],{i,ParamNr[arch]}] /. sol[[1]] /. {p[1]\[Rule] n}]]

ParamTest[arch_][param_,n_]:=
  And[param[[n]]\[GreaterEqual] ParamMin[arch][param,n], 
    param[[n]]\[LessEqual] ParamMax[arch][param,n]]

ParamTest[arch_][param_]:=
  And@@Table[ParamTest[arch][param,n],{n,Length[param]}]

ClockCycle[arch_][param_]:=
  WorkUnit[arch][param]/NeededCycles[arch][param,WorkUnit[arch][param]]

NeededCycles[arch_][param_,{mults_,adds_}]:=1

Throughput[arch_][param_]:=param[[2]] / ResponseTime[arch][param]

ResponseTime[arch_][param_]:= NeededCycles[arch][param,WorkUnit[arch][param]]

Usage[arch_][param_]:=1/NeededCycles[arch][param,WorkUnit[arch][param]]

ConstantsNr[arch_][param_]:=HardwareMultipliers[arch][param]

ConstantsUniqueNr[arch_][param_]:=ConstantsNr[arch][param]

End[]





Map[Get["Architecture`"<>#1 <>"`"]&,ArchitectureList]



EndPackage[]