(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





BeginPackage["Architecture`SLA`","Architecture`Main`"]



Begin["`Private`"]



Description[
    "SLA"]:="The SLA architecture is based on the scattered look-ahead \
approach with decomposition. We assumed direct form implementations running \
in parallel for the recursive part and  parallel fir filters for the \
nonrecursive part. state space form of the filter. Because of the \
decomposition this architecture has the restriction that the second parameter \
needs to be a power of two. Note that the characteristics of this \
architecture may change if a different implementation of the nonrecursive and \
recursive parts was chosen (Fast FIR filtering techniques for the \
nonrecursive part for example). See: zhou88twolevel, brent91stabilized, \
parhi88pipelined, parhi89pipeline."

ParamTest["SLA"][param_,2]:=
  And[param[[2]]\[GreaterEqual] 1,
    Round[Log[2,param[[2]]]]\[Equal] Log[2,param[[2]]]]

WorkUnit["SLA"][param_]:={1,param[[1]]}

HardwareMultipliers["SLA"][{N_,P_}]:=P (Log[2,P] + 2) N + P

HardwareAdders["SLA"][{N_,P_}]:=N P (Log[2,P] + 2) + P

HardwareBuffers["SLA"][{N_,P_}]:= P N

Latency["SLA"][{N_,P_}]:=ResponseTime[arch_][param_] * ((Log[2,P]+1)N + 2)

End[]



EndPackage[]