(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





BeginPackage["Architecture`SLAIncr`","Architecture`Main`"]



Begin["`Private`"]



Description[
    "SLAIncr"]:="The SLA architecture with incremental output computation is \
based on the scattered look-ahead approach with decomposition. We assumed \
direct form implementations running in parallel for the recursive part and  \
parallel fir filters for the nonrecursive part of the first N outputs. The \
other outputs are calculated using incremental output computation. Because of \
the decomposition this architecture has the restriction that the second \
parameter needs to be a power of two. Note that the characteristics of this \
architecture may change if a different implementation of the nonrecursive and \
recursive parts was chosen (Fast FIR filtering techniques for the \
nonrecursive part for example). Note that the incremental output computation \
is not very effective; The filter consists of an IIR stage and several FIR \
stages. Only one of these stages (the last one) can be reduced, because the \
others all have to all their outputs since they are needed by the next stage \
to calculate their outputs. See: zhou88twolevel, brent91stabilized, \
parhi88pipelined, parhi89pipeline."

ParamTest["SLAIncr"][param_,2]:=
  And[param[[2]]\[GreaterEqual] 1,
    Round[Log[2,param[[2]]]]\[Equal] Log[2,param[[2]]]]

WorkUnit["SLAIncr"][param_]:={1,param[[1]]}

HardwareMultipliers["SLAIncr"][{N_,P_}]:=
  If[P\[GreaterEqual] N,P (Log[2,P] + 2) N + P -(P-N)N + (P-N)(2N+1),
    P (Log[2,P] + 2) N + P]

HardwareAdders["SLAIncr"][{N_,P_}]:=
  If[P\[GreaterEqual] N,P (Log[2,P] + 2) N + P -(P-N)N + (P-N)(2N+1),
    P (Log[2,P] + 2) N + P]

HardwareBuffers["SLAIncr"][{N_,P_}]:= P N

Latency["SLAIncr"][{N_,P_}]:=
  ResponseTime[arch_][param_] * ((Log[2,P]+1)N + 2) + 
    If[P\[GreaterEqual] N, P-N,0]

End[]



EndPackage[]